import { RabbitSubscribe } from '@golevelup/nestjs-rabbitmq';
import { Controller, Inject } from '@nestjs/common';
import { WINSTON_MODULE_PROVIDER } from 'nest-winston';
import { Logger } from 'winston';
import { level } from './logger/level.enum';
import loggerOptions from './logger/logger';

@Controller()
export class GatewayApiController {
  constructor(
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
  ) {}

  @RabbitSubscribe({
    name: 'loggingGatewayApiHealthCrit',
  })
  public async gatewayApiHealthCriticalHandler(message: string) {
    this.logger.configure(
      loggerOptions('gateway-api', level.crit, 'crit', 'health'),
    );
    this.logger.crit(JSON.parse(message));
  }
}
